<template>
  <div>
    <v-container fill-height fluid>
      <div style="width:900px;">
        <v-row>
          <v-col cols="12" md="12" class="text-center">
            <v-toolbar-title class="align-center">
              <v-icon class="mb-1" size="40" dark>mdi-lock</v-icon>
              <h2 class="colorHeader">24Lock</h2>
            </v-toolbar-title>
          </v-col>

          <v-col
            cols="12"
            xs="6"
            sm="6"
            md="6"
            lg="6"
            xl="6"
            v-for="card in items"
            :key="card.lkRoomCode"
          >
            <v-container>
              <v-hover v-slot:default="{ hover }" open-delay="100">
                <v-card
                  class="mx-auto"
                  max-width="600"
                  :disabled="card.disable"
                  :color="card.color"
                  @click="goTo(card)"
                  :elevation="hover ? 15 : 2"
                >
                  <v-container>
                    <v-row>
                      <v-col cols="6" sm="6" md="6" lg="6" xl="6">
                        <v-card-title class="headline mb-1">{{
                          card.lkRoomCode
                        }}</v-card-title>

                        <v-card-text>
                          <span class="subtitle d-flex justify-start"
                            >{{ card.subtitleThai }} -
                            {{ card.subtitleEng }}</span
                          >
                        </v-card-text>
                      </v-col>
                      <v-col cols="12" sm="6" md="6" lg="6" xl="6">
                        <v-card-title class="headline d-flex justify-end">
                          <v-icon :color="getColor(card.status)" dark
                            >fiber_manual_record</v-icon
                          >
                        </v-card-title>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-card>
              </v-hover>
            </v-container>
          </v-col>
        </v-row>
      </div>
      <v-row justify="center">
        <v-dialog v-model="dialog2" persistent max-width="460">
          <v-card>
            <div align="center">
              <v-card-title class="headline">
                กรุณาขอ Passcode จาก App เพื่อปลดล็อก
              </v-card-title>
            </div>

            <div align="center">
              <v-btn color="green darken-1" text @click="dialog2 = false">
                ตกลง
              </v-btn>
            </div>
            <br />
          </v-card>
        </v-dialog>
      </v-row>
      <v-dialog v-model="dialog" persistent max-width="600px">
        <AddDialog
          v-bind:formDialog="formDialog"
          @close="close"
          @login="login"
        />
      </v-dialog>
      <v-snackbar
        :color="color"
        v-model="snackbar"
        :timeout="timeout"
        right
        top
      >
        {{ text }}
        <template v-slot:action="{ attrs }">
          <v-btn text v-bind="attrs" @click="snackbar = false">Close</v-btn>
        </template>
      </v-snackbar>
    </v-container>
  </div>
</template>

<script>
import AddDialog from "../Home/AddDialog";
import Snackbar from "../Snackbar/Snackbar";
import { mapActions, mapState } from "vuex";

export default {
  name: "Card",
  data() {
    return {
      dialog: false,
      dialog2: false,
      cards: [],
      formDialog: {},
      snackbar: false,
      text: "",
      timeout: 2000,
      color: "",
      defalutFormDialog: {
        link: "",
        title: "",
        subtitle: "",
        status: "",
        color: "",
      },
    };
  },
  components: {
    AddDialog,
    Snackbar,
  },
  async created() {
    await this.$store.dispatch("locker/getLocker", 18010);
  },
  computed: {
    ...mapState("locker", ["items", "openStatus"]),
  },
  methods: {
    async goTo(event) {
      await this.$store.dispatch("locker/checkStatus", event.lkRoomId);
      let checkBooking = this.$store.getters["locker/statusBooking"];
      if (checkBooking == false) {
        this.dialog2 = true;
      } else {
        this.formDialog = event;
        this.dialog = true;
      }
    },
    login(event) {
      if (event == false) {
        this.snackbar = true;
        this.color = "error";
        this.text = "Password incorrect";
      } else if (event == 401) {
        this.snackbar = true;
        this.color = "error";
        this.text = "กรุณาขอ Passcode จาก App";
      } else {
        this.snackbar = true;
        this.color = "success";
        this.text = "Booking success";
        for (let i in this.items) {
          if (event.lkRoomCode === this.items[i].lkRoomCode) {
            this.items[i] = event;
          }
        }
        this.dialog = false;
      }
    },
    close(event) {
      this.dialog = event;
      this.formDialog = Object.assign({}, this.defalutFormDialog);
      this.snackbar = false;
    },
    getColor(color) {
      if (color == "A") return "green";
      else if (color == "B") return "red";
      else if (color == "F") return "orange";
    },
  },
};
</script>

<style>
.colorHeader {
  color: rgb(255, 255, 255);
}
.slider-wrapper {
  font-size: 10px;
  color: #aaa;
  font-weight: bold;
  text-transform: uppercase;
  display: flex;
  align-items: center;
  justify-content: center;
}
.slider {
  height: 20px;
  overflow: hidden;
}
.slider div {
  color: #fff;
  height: 20px;
  margin-bottom: 50px;
  padding: 2px 5px;
  text-align: center;
  box-sizing: border-box;
}
.slider-text1 {
  background: lightgreen;
  animation: slide 8s linear infinite;
}
.slider-text2 {
  background: lightgreen;
}

.slider-wrapper1 {
  font-size: 10px;
  color: #aaa;
  font-weight: bold;
  text-transform: uppercase;
  display: flex;
  align-items: center;
  justify-content: center;
}
.slider1 {
  height: 20px;
  overflow: hidden;
}
.slider1 div {
  color: #fff;
  height: 20px;
  margin-bottom: 50px;
  padding: 2px 5px;
  text-align: center;
  box-sizing: border-box;
}
.slider-text11 {
  background: #ffc107;
  animation: slide 8s linear infinite;
}
.slider-text22 {
  background: #ffc107;
}

@keyframes slide {
  0% {
    margin-top: -110px;
  }
  5% {
    margin-top: -100px;
  }
  33% {
    margin-top: -50px;
  }
  38% {
    margin-top: -50px;
  }
  66% {
    margin-top: -5px;
  }
  71% {
    margin-top: 0px;
  }
  100% {
    margin-top: 50px;
  }
}
</style>
